From: =?utf-8?q?Guido_G=C3=BCnther?= <agx@sigxcpu.org>
Date: Thu, 12 Sep 2019 12:38:28 -0700
Subject: sound: wm8962: delay probe due to i2c not being ready
MIME-Version: 1.0
Content-Type: text/plain; charset="utf-8"
Content-Transfer-Encoding: 8bit

another device on i2c2 that times out during first probe

need to investigate why the imx8mq's i2c controller is not ready
although it claims to be - missing clock?

Signed-off-by: Guido Günther <guido.gunther@puri.sm>
---
 sound/soc/codecs/wm8962.c | 9 +++++++++
 1 file changed, 9 insertions(+)

diff --git a/sound/soc/codecs/wm8962.c b/sound/soc/codecs/wm8962.c
index a5584ba..ef929e4 100644
--- a/sound/soc/codecs/wm8962.c
+++ b/sound/soc/codecs/wm8962.c
@@ -35,6 +35,9 @@
 
 #include "wm8962.h"
 
+static int defers;
+#define MAX_DEFERS 1
+
 #define WM8962_NUM_SUPPLIES 8
 static const char *wm8962_supply_names[WM8962_NUM_SUPPLIES] = {
 	"DCVDD",
@@ -3550,6 +3553,12 @@ static int wm8962_i2c_probe(struct i2c_client *i2c,
 	unsigned int reg;
 	int ret, i, irq_pol, trigger;
 
+	if (defers < MAX_DEFERS) {
+		printk("%s: %d: defering probe", __func__, __LINE__);
+		defers++;
+		return -EPROBE_DEFER;
+	}
+
 	wm8962 = devm_kzalloc(&i2c->dev, sizeof(*wm8962), GFP_KERNEL);
 	if (wm8962 == NULL)
 		return -ENOMEM;
